//
//
//

class SnowMaker extends effects;

var() int MaxFlakes;
var() float FlakeDensity;

var int Flakecount;
var float dropDistance;
var float timer;
var float droptime;

function Tick(float deltaTime)
 {
 local float distance;
 local int direction;
 local SnowFlake flake;
 local vector loc;
 local rotator r;
 // spawn a flake if needs be
 if (Flakecount>=MaxFlakes)
    return;

 timer+=deltaTime;
 if (timer<droptime)
    return;

 // spawn that flake in a random location
 direction=Rand(65535);
 distance=FRand()*CollisionRadius;
 r=RotRand();
 r.Pitch=0;
 r.Roll=0;
 loc=Location+(Normal(Vector(r))*distance);
 flake=Spawn(class'SnowFlake',,,loc);
 if (flake==none)
    return;
 timer=0.0;
 flake.DrawScale=0.05+(FRand()*0.2);
 flake.Scaleglow=0.1+(FRand()*0.3);
 flake.master=self;
 flake.Mass*=(1.0+(flake.drawScale*3));
 flake.Velocity=vect(0,0,-450);
 Flakecount++;
 flake.textureNum=Rand(3);
 //flake.skin=tex[i];
 droptime=1.05-FlakeDensity;
 }

function PostBeginPlay()
 {
 local vector start,end,hl,hn;
 local Actor A;
 local bool bFoundFloor;
 super.PostBeginPlay();
 start=Location;
 end=Location+Vect(0,0,-2048);
 do
   {
   A=Trace(hl,hn,end,start);
   if (A==Level)
      {
      bFoundFloor=true;
      dropdistance=VSize(Location-hl);
      }
   else
       {
       start=hl;
       if (A==none || start==end)
          bFoundFloor=true;
       }
   } until (bFoundFloor);

 }

function LoseADrop()
 {
 Flakecount--;
 }

defaultproperties
{
     MaxFlakes=256
     FlakeDensity=0.990000
     bHidden=True
     DrawType=DT_Sprite
     Texture=Texture'Engine.S_Inventory'
     CollisionRadius=88.000000
     CollisionHeight=2.000000
     bCollideActors=True
}